@echo off
set DEBUG=0
rem Batch file name: mcopy.bat
rem copy files to multiple servers listed below, or to a single
rem server name entered from command prompt.
rem
rem Can be modified to run any commands, such as copying updated config 
rem or host files, checking volume space, or gathering logs.
REM
Rem Automate commands on multiple servers
Rem by Scott McClelland, CNE, MCSE, A+, 07/10/2002
rem systemnotes@yahoo.com
rem modified 10/22/2002 - added MYFILEPATH variable
rem modified 10/24/2002 - made current directory the default path
rem modifed 02/24/03 - connect to Windows shares
rem modifed 0304/03 - added /f option to set vars from a separate file
rem also added for loop to clear variables
rem modified 03/06/03 - added call to mcopyauth.bat to keep authentication separate
rem
Rem The idea is to be able to enter server names and commands in one place
Rem and have the commands run on all servers.  An example would be to copy
Rem files to 40 servers, or get and combine log files from all servers.
rem
Rem ************** User Input ************** 
REM Enter available drive letter here
Set DRVMAP=R:
set MYSHARE=c$

Rem Enter location of source files (may need to include trailing '\')
set MYFILEPATH=.\

rem ---------- Directory Locations ---------- 
set MSPATCHPATH=\\cpq-img\SOS_Files\Microsoft\patching_project
set MSSPPATH=\\cpq-img\SOS_Files\Microsoft\W2K_SP3_and_patches
set CPQSPPATH=\\cpq-img\SOS_Files\Compaq
set DESTINATIONDIR=install\patches

rem ---------- Directories to copy ---------- 
set MSPATCHDIRS=*.*
set MSSPDIR=W2K_SP3\
set CPQSPDIR=w2k_support_paq_6.20a\

rem ---------- set authentication for Windows servers ----------
rem leave authcmd vars blank (AUTHCMD= ) to connect as current user, or call from mcopyauth.bat
set AUTHDOMAIN=
set AUTHUSER=
set AUTHPASSWD=
if exist mcopyauth.bat call mcopyauth.bat
set AUTHCMD=%AUTHPASSWD% /user:%AUTHDOMAIN%\%AUTHUSER%


rem ----- ** Enter Server Names Here, or single servername from command prompt: ** -----

set SV000=


rem Server name entered from command prompt will be the only one processed:
if NOT %1!==! set SV000=%1
set SV001=
set SV002=
set SV003=
set SV004=
set SV005=
set SV006=
set SV007=
set SV008=
set SV009=
set SV0010=

set SV011=
set SV012=
set SV013=
set SV014=
set SV015=
set SV016=
set SV017=
set SV018=
set SV019=
set SV020=

set SV021=
set SV022=
set SV023=
set SV024=
set SV025=
set SV026=
set SV027=
set SV028=
set SV029=
set SV030=
set SV031=
set SV032=
set SV033=
set SV034=
set SV035=
set SV036=
set SV037=

set SV038=
set SV039=
set SV040=

set SV041=
set SV042=
set SV043=
set SV044=
set SV045=
set SV046=
set SV047=
set SV048=
set SV049=

rem call bat to set vars rather than typing them in above.
rem useage: mupdate /f filename
if %1!==/f! if !%2==! (
    call srv.bat
) ELSE ( 
    if %1!==/f! call %2.bat
    if %1!==/F! call %2.bat
)

Rem Make sure there were no left over commands.
SET CMD1=
SET CMD2=
SET CMD3=
SET CMD4=
SET CMD5=

Rem Enter Commands to run:
set CMD1=if not exist %DRVMAP%\%DESTINATIONDIR% md %DRVMAP%\%DESTINATIONDIR%
set CMD2= xcopy %MSPATCHPATH%\%MSPATCHDIRS% %DRVMAP%\%DESTINATIONDIR% /s/i/v/e/c/y
rem set CMD1= echo copying...
rem set CMD2= copy %MSPATCHPATH%\updates.bat %DRVMAP%\%DESTINATIONDIR%
set CMD3= echo Finished...
SET CMD4= echo .............................................................
set CMD5=


REM Enter Description to echo to client
Set DESCR1= Copy patches to multiple servers
Set DESCR2= useage:mcopy /f filename (e.g. %0 /f srv)

Rem ************** End User Input ************** 
Rem if no input or SV variables, echo some help for the user
if %SV000%!==! if %1!==! goto help
if %1!==/h! goto help
if %1!==/H! goto help
if %1!==/help! goto help
if %1!==/HELP! goto help
if %1!==--help! goto help

:top
Echo for servers:
for %%f in (%SV000%, %SV001%, %SV002%, %SV003%, %SV004%, %SV004%, %SV006%, %SV007%,...) do echo %%f
Echo Running commands: 
rem if NOT !"%CMD1%"==!"" echo %CMD1%
if NOT !"%CMD2%"==!"" echo %CMD2%
if NOT !"%CMD3%"==!"" echo %CMD3%
if NOT !"%CMD4%"==!"" echo %CMD4%
if NOT !"%CMD5%"==!"" echo %CMD5%
echo.
if NOT !"%DESCR1%"==!"" echo %DESCR1%
if NOT !"%DESCR2%"==!"" echo %DESCR2%
echo.

:run
set CURR_SRV=%SV000%
net use %DRVMAP% \\%SV000%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

REM ******** Uncomment as needed for Debugging *********
rem goto cleanup
rem goto end

Rem Goto end if a single server was entered from the command prompt
if %1!==/f! goto next
if %1!==/F! goto next
if NOT %1!==! goto cleanup
:next

set CURR_SRV=%SV001%
echo %SV001%
net use %DRVMAP% \\%SV001%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV002%
echo %SV002%
net use %DRVMAP% \\%SV002%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV003%
echo %SV003%
net use %DRVMAP% \\%SV003%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV004%
echo %SV004%
net use %DRVMAP% \\%SV004%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV005%
echo %SV005%
net use %DRVMAP% \\%SV005%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV006%
echo %SV006%
net use %DRVMAP% \\%SV006%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV007%
echo %CURR_SRV%
net use %DRVMAP% \\%SV007%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV008%
echo %CURR_SRV%
net use %DRVMAP% \\%SV008%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV009%
echo %CURR_SRV%
net use %DRVMAP% \\%SV009%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

REM *********************************************************
Echo First 10 Completed....
REM *********************************************************

set CURR_SRV=%SV010%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV011%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV012%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV013%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV014%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV015%
echo %CURR_SRV%
net use %DRVMAP% \\%CURR_SRV%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

rem ........................................
set CURR_SRV=%SV016%
echo %CURR_SRV%
rem ........................................
net use %DRVMAP% \\%SV016%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV017%
echo %CURR_SRV%
net use %DRVMAP% \\%SV017%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV018%
echo %CURR_SRV%
net use %DRVMAP% \\%SV018%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV019%
echo %CURR_SRV%
net use %DRVMAP% \\%SV019%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

REM *********************************************************
Echo First 20 Completed....
REM *********************************************************

set CURR_SRV=%SV020%
echo %CURR_SRV%
net use %DRVMAP% \\%SV020%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV021%
echo %CURR_SRV%
net use %DRVMAP% \\%SV021%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV022%
echo %CURR_SRV%
net use %DRVMAP% \\%SV022%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV023%
echo %CURR_SRV%
net use %DRVMAP% \\%SV023%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV024%
echo %CURR_SRV%
net use %DRVMAP% \\%SV024%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV025%
echo %CURR_SRV%
net use %DRVMAP% \\%SV025%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV026%
echo %CURR_SRV%
net use %DRVMAP% \\%SV026%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV027%
echo %CURR_SRV%
net use %DRVMAP% \\%SV027%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV028%
echo %CURR_SRV%
net use %DRVMAP% \\%SV028%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

set CURR_SRV=%SV029%
echo %CURR_SRV%
net use %DRVMAP% \\%SV029%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

REM *********************************************************
Echo First 30 Completed....
REM *********************************************************

set CURR_SRV=%SV030%
echo %CURR_SRV%
net use %DRVMAP% \\%SV030%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV031%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV032%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV033%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV034%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV035%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV036%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP% > nul

net use %DRVMAP% \\%SV037%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV038%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV039%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV040%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV041%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV042%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV043%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV044%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

net use %DRVMAP% \\%SV045%\%MYSHARE% %AUTHCMD%
%CMD1%
%CMD2%
%CMD3%
%CMD4%
net use /delete %DRVMAP%

:: Done
goto cleanup

:help
echo. 
echo -------------------------------------
echo Help Info:
echo.
echo Copy patches to multiple servers
echo.
echo useage:mcopy /f filename (e.g. %0 /f srv)
echo.
echo or %0 /i (to use internal vars)
echo.

:cleanup
if %DEBUG%==1 goto debug
Rem Cleanup Variables

rem Clear server SVx variables from 000 to 999
for %%f in (0, 1, 2, 3, 4, 5, 6, 7, 8, 9) do for %%g in (0, 1, 2, 3, 4, 5, 6, 7, 8, 9) do for %%h in (0, 1, 2, 3, 4, 5, 6, 7, 8, 9) do set SV%%f%%g%%h=

set SV001=
set SV002=
set SV003=
set SV004=
set SV005=
set SV006=
set SV007=
set SV008=
set SV009=
set SV010=
set SV011=
set SV012=
set SV013=
set SV014=
set SV015=
set SV016=
set SV017=
set SV018=
set SV019=
set SV020=
set SV021=
set SV022=
set SV023=
set SV024=
set SV025=
set SV026=
set SV027=
set SV028=
set SV029=
set SV030=
set SV031=
set SV032=
set SV033=
set SV034=
set SV035=
set SV036=
set SV037=
set SV038=
set SV039=
set SV040=
set SV041=
set SV042=
set SV043=
set SV044=
set SV045=
set SV046=
set SV047=
set SV048=
set SV049=

SET CMD1=
SET CMD2=
SET CMD3=
SET CMD4=
SET CMD5=

set AUTHDOMAIN=
set AUTHUSER=
set AUTHPASSWD=
set AUTHCMD=

set CURR_SRV=
goto end
:debug
echo SV000=%SV000%
:end
