#!/usr/bin/perl -w
# getvars.pl by Scott McClelland 03/04/03
# designed to work with mcopy.bat
#
# Open a file, and write the output to another file, 
# but prepend "set SVxxx="
# useful for setting environment variables for a .bat file to use
# requries input file with one variable (i.e. servername) per line

# initialize variables
$a="vmservers.txt";
$b="vmsrv.bat";
$i=0;
$j=0;
$k=0;

# Open file for reading
open(IN,$a) || die "cannot open $a for reading: $!";
# Open file for writing
open(OUT,">$b") || die "cannot open $b for writing: $!";
while (<IN>) {      # read a line from file $a into $_
	# skip blank and comment lines
	next if /^\s*$/;
	next if /^#/;
	
	# write the vars to output file, adding "set svxxx=" to the beginning of the line
	print OUT "set SV$k$j$i=$_";
# We could set vars here, but they are not necessarily persistent.
#	system ("set", "SV$k$j$i=$_");
#	instead, we write them to a .bat file
	$ENV{"SV$k$j$i"}="$_";
	
	# increment the index
	$i=$i+1;
	
	# pad with zeros to match batch file loop of 000 to 999
	if ($i==10) {$i=0;$j=$j+1};
	if ($j==10) {$j=0;$k=$k+1};
}
# close files
close(IN) || die "can't close  $a: $!";
close(OUT) || die "can't close  $b: $!";

